/*
 * HPT302/302N UDMA/ATA133 Controller Device Driver for Linux
 * Copyright (C) 2000-2003 HighPoint Technologies, Inc.
 * hpttempl.h  Scsi host template definition
 */
#define DRIVER_NAME "HPT302/302N UDMA/ATA133 Controller driver"
#define PROC_DIR_NAME "hpt302"

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,5,0)
#define HPT3xx {\
	proc_name:			     PROC_DIR_NAME,         \
	proc_info:			     hpt3xx_ProcInfo26,     \
	name:				     PROC_DIR_NAME,         \
	detect:				     hpt3xx_Detect,		    \
	release:			     hpt3xx_Release,		\
	queuecommand:		     hpt3xx_QueueCommand,   \
	abort:				     NULL,		            \
	reset:				     NULL,		            \
	eh_abort_handler:        hpt3xx_Abort,          \
    eh_device_reset_handler: hpt3xx_Reset,          \
    eh_bus_reset_handler:    hpt3xx_Reset,          \
    eh_host_reset_handler:   NULL,                  \
	can_queue:			     MAX_QUEUE_COMM,		\
	this_id:			     -1,					\
	sg_tablesize:		     16,					\
	cmd_per_lun:		     MAX_QUEUE_COMM,		\
	present:			      0,					\
	unchecked_isa_dma:	      0,					\
	use_clustering:		      DISABLE_CLUSTERING,	\
}

#elif LINUX_VERSION_CODE >= KERNEL_VERSION(2,3,0)
#define HPT3xx {\
	proc_name:			     PROC_DIR_NAME,         \
	proc_info:			     hpt3xx_ProcInfo,       \
	name:				     PROC_DIR_NAME,         \
	detect:				     hpt3xx_Detect,		    \
	release:			     hpt3xx_Release,		\
	command:			     hpt3xx_Command,		\
	queuecommand:		     hpt3xx_QueueCommand,   \
	abort:				     NULL,		            \
	reset:				     NULL,		            \
	eh_abort_handler:        hpt3xx_Abort,          \
    eh_device_reset_handler: hpt3xx_Reset,          \
    eh_bus_reset_handler:    hpt3xx_Reset,          \
    eh_host_reset_handler:   NULL,                  \
	bios_param:			     hpt3xx_BiosParam,	    \
	can_queue:			     MAX_QUEUE_COMM,		\
	this_id:			     -1,					\
	sg_tablesize:		     16,					\
	cmd_per_lun:		     MAX_QUEUE_COMM,		\
	present:			      0,					\
	unchecked_isa_dma:	      0,					\
	use_clustering:		      DISABLE_CLUSTERING,	\
    use_new_eh_code:	      1 					\
}

#else /* 2.2.x */

extern struct proc_dir_entry proc_scsi_hpt3xx;

#define HPT3xx {\
	proc_dir:			     &proc_scsi_hpt3xx,     \
	proc_info:			     hpt3xx_ProcInfo,       \
	name:				     PROC_DIR_NAME,         \
	detect:				     hpt3xx_Detect,		    \
	release:			     hpt3xx_Release,		\
	command:			     hpt3xx_Command,		\
	queuecommand:		     hpt3xx_QueueCommand,   \
	abort:				     NULL,		            \
	reset:				     NULL,		            \
	eh_abort_handler:        hpt3xx_Abort,          \
    eh_device_reset_handler: hpt3xx_Reset,          \
    eh_bus_reset_handler:    hpt3xx_Reset,          \
    eh_host_reset_handler:   NULL,                  \
	bios_param:			     hpt3xx_BiosParam,	    \
	can_queue:			     MAX_QUEUE_COMM,	    \
	this_id:			     -1,					\
	sg_tablesize:		     16,					\
	cmd_per_lun:		     MAX_QUEUE_COMM,	    \
	present:			     0,					    \
	unchecked_isa_dma:	     0,					    \
	use_clustering:		     DISABLE_CLUSTERING,	\
    use_new_eh_code:	     1					    \
}
#endif
